# Generated by Django 4.2.3 on 2023-08-02 08:50

from django.db import migrations, models
import django.db.models.deletion
import uuid


class Migration(migrations.Migration):
    initial = True

    dependencies = []

    operations = [
        migrations.CreateModel(
            name="Answer",
            fields=[
                ("id", models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("title", models.CharField(max_length=364)),
                ("is_correct", models.BooleanField()),
            ],
            options={
                "verbose_name": "Answer",
                "verbose_name_plural": "Answers",
            },
        ),
        migrations.CreateModel(
            name="Invitation",
            fields=[
                ("id", models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("email", models.EmailField(max_length=254, verbose_name="email address")),
                ("token", models.UUIDField(default=uuid.uuid4, editable=False, unique=True)),
                (
                    "last_attempt_at",
                    models.DateTimeField(
                        blank=True, help_text="The date when last email sending attempt happened", null=True
                    ),
                ),
                (
                    "sent_at",
                    models.DateTimeField(
                        blank=True, help_text="The date when email has been successfully sent to the invitee", null=True
                    ),
                ),
                ("accepted", models.BooleanField(default=False)),
            ],
            options={
                "verbose_name": "Invitation",
                "verbose_name_plural": "Invitations",
            },
        ),
        migrations.CreateModel(
            name="Question",
            fields=[
                ("id", models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("title", models.CharField(max_length=364)),
            ],
            options={
                "verbose_name": "Question",
                "verbose_name_plural": "Questions",
            },
        ),
        migrations.CreateModel(
            name="Quiz",
            fields=[
                ("id", models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("title", models.CharField(max_length=364)),
                ("description", models.TextField(blank=True, max_length=128)),
                (
                    "status",
                    models.CharField(
                        choices=[("draft", "draft"), ("active", "active"), ("finished", "finished")],
                        default="draft",
                        max_length=8,
                    ),
                ),
            ],
            options={
                "verbose_name_plural": "Quizzes",
            },
        ),
        migrations.CreateModel(
            name="QuizParticipant",
            fields=[
                ("id", models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("quiz", models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to="quizzes.quiz")),
            ],
            options={
                "verbose_name": "Quiz Participant",
                "verbose_name_plural": "Quiz Participants",
            },
        ),
        migrations.CreateModel(
            name="QuizParticipantAnswer",
            fields=[
                ("id", models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("created_at", models.DateTimeField(auto_now_add=True)),
                ("answers", models.ManyToManyField(to="quizzes.answer")),
                (
                    "participant",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="answered_questions",
                        to="quizzes.quizparticipant",
                    ),
                ),
                ("question", models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to="quizzes.question")),
            ],
            options={
                "verbose_name": "Quiz Participant Answer",
                "verbose_name_plural": "Quiz Participant Answers",
            },
        ),
    ]
